AC_DEFUN(GST_DOUBLE_ALIGNMENT, [

AC_CACHE_CHECK(for double alignment, gst_cv_double_alignment, [
AC_TRY_RUN([
  main()
  {
    long vec[3];
    double *doubleptr;
    long ptr;
    char buffer[200];

    if (sizeof(double) == sizeof(long)) {
      /* The alignment cannot be bigger than the size,
       * so quit. */
      exit(0);
    }

    /* Find a position in vec so that doubleptr is misaligned. */
    ptr = (long) vec;			/* xxxxxxxxxxxxxyyy */
    ptr |= sizeof(double) - 1;		/* xxxxxxxxxxxxx111 */
    ptr ^= sizeof(long) - 1;		/* xxxxxxxxxxxxx100 */
    doubleptr = (double *) ptr;

    /* The sprintf only fools the compiler, what's important is
     * that we dereference doubleptr */
    sprintf(buffer, "%d", *doubleptr);
    exit(0);
  }],
  gst_cv_double_alignment=SIZEOF_LONG,
  gst_cv_double_alignment="(2 * SIZEOF_LONG)",
  gst_cv_double_alignment="(2 * SIZEOF_LONG)")     dnl Assume the worst
])

AC_DEFINE_UNQUOTED(DOUBLE_ALIGNMENT, $gst_cv_double_alignment,
               [Define this to the memory alignment required by type "double"])

])dnl
